
#include <stdio.h>
#include <stdlib.h>
#include "rif_f.h"
#include "cell.h"
#include "sif.h"

extern void	Error(char *);

int	main(int argc,char **argv)
{
	int	Nx,Ny,BPS,y,x;
	FOM	**F;
	char	*desc;
	Cell	C,**I;
	double	f1,f2,base,step;

	if (argc!=4 && argc!=6)
	    Error("usage : t_f2i TIFF_float {base step} BPS TIFF_int");

	if (ReadImageFile_Float(argv[1],&Nx,&Ny,&F,&desc))
	    (void)fprintf(stderr,
			  "%s : containing non-float pixel values (warning).\n",
			  argv[1]);

	if ((BPS=atoi(argv[argc-2]))<1 || BPS>sizeof(Cell)*8)
	    Error("bad bit per sample (BPS).");

	C=(Cell)((1<<BPS)-1);
	if (argc==4) {
	    f1=f2=F[0][0];
	    for (y=0; y<Ny; y++)
	    for (x=0; x<Nx; x++) if (F[y][x]<f1) f1=F[y][x]; else
				 if (F[y][x]>f2) f2=F[y][x];

	    base=f1; step=(f1<f2)?(f2-f1)/(double)C:1.0;

	    (void)printf("%lf\t%lf\n",f1,f2);
	}
	else {
	    if ((step=atof(argv[3]))<=0.0) Error("bad value step.");

	    f2=(f1=base=atof(argv[2]))+step*(double)C;
	}
	I=(Cell **)F;
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++)
	    I[y][x]=(F[y][x]<=f1)?0:
		    (F[y][x]>=f2)?C:(Cell)((F[y][x]-base)/step+0.5);

	StoreImageFile(argv[argc-1],Nx,Ny,BPS,I,desc);

	return 0;
}
