
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif_f.h"

extern void	Error(char *);

int	main(int argc,char **argv)
{
	int	Nx,Ny,y,x;
	Cell	**I;
	char	*desc;
	FOM	**F;
	double	base,step;

	if (argc!=5) Error("usage : t_i2f TIFF_int base step TIFF_float");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&I,&desc);

	if ((F=(FOM **)malloc(sizeof(FOM *)*Ny))==NULL ||
	    (*F=(FOM *)malloc(sizeof(FOM)*Ny*Nx))==NULL)
	    Error("memory allocation error.");

	base=atof(argv[2]);
	step=atof(argv[3]);

	for (y=0; y<Ny; y++) {
	    if (y>0) F[y]=F[y-1]+Nx;

	    for (x=0; x<Nx; x++) F[y][x]=base+step*(double)I[y][x];
	}
	StoreImageFile_Float(argv[4],Nx,Ny,F,desc);

	return 0;
}
